rm(list=ls(all=TRUE))
n=50
arch=function(){
  temp=rep(0,(n+100))
  temp[1]=rnorm(1)
  e=rlaplace((n+100),0,1/sqrt(2))
  for (i in 1:(n-1+100)){
    temp[i+1]=sqrt(.5+.25*temp[i]^2)*e[i+1]
  }
  x=temp[101:(100+n)]
  y=x^2
  #weight u=v
  v=rep(NA,n-1)
  for(i in 1:(n-1)) v[i]=(1+y[i])^(-1)
  #WLE1
  fit=lm(y[-1]~y[-n],weights=v)
  
  #WLE2
  denom=matrix(0,nrow=2,ncol=2)
  num=rep(0,2)
  for(i in 1:(n-1)){
    s=(c(1,y[i])%*%fit$coef)^2
    s=as.numeric(s)
    denom=v[i]*c(1,y[i])%*%t(c(1,y[i]))/s+denom
    num=v[i]*c(1,y[i])*y[i+1]/s+num
  }
  #betahat
  betahat=solve(denom)%*%num
  
  #residuals
  e=rep(NA,n-1)
  for(i in 1:(n-1)){
    e[i]=x[i+1]/sqrt(betahat[1]+betahat[2]*y[i])
  }
  e=e[!is.na(e)]
  er=e-mean(e)
  resid=rep(NA,n-1)
  for(j in 1:(n-1)){
    tempfit=lm(y[-c(1,j+1)]~y[-c(j,n)],weights=v[-j])#tempwle1
    tempdenom=matrix(0,nrow=2,ncol=2)
    tempnum=rep(0,2)
    for(i in 1:(n-1)){
      if(i!=j){
        s=(c(1,y[i])%*%tempfit$coef)^2
        s=as.numeric(s)
        tempdenom=v[i]*c(1,y[i])%*%t(c(1,y[i]))/s+tempdenom
        tempnum=v[i]*c(1,y[i])*y[i+1]/s+tempnum
      }
    }
    tempbetahat=solve(tempdenom)%*%tempnum#tempwle2
    resid[j]=x[j+1]/sqrt(tempbetahat[1]+tempbetahat[2]*y[j])
  }
  resid=resid[!is.na(resid)]
  res=resid-mean(resid)
  
  #bootstrap
  futurestar=rep(NA,1000)
  futurestar1=rep(NA,1000)
  for(B in 1:1000){
    w=rmultinom(1,n-1,rep(1/(n-1),n-1))
    sigma=sqrt(1-1/(n-1))
    w=w*v
    fitstar=lm(y[-1]~y[-n],weights=w)
    denomstar=matrix(0,nrow=2,ncol=2)
    numstar=rep(0,2)
    for(i in 1:(n-1)){
      s=(c(1,y[i])%*%fitstar$coef)^2
      s=as.numeric(s)
      denomstar=w[i]*c(1,y[i])%*%t(c(1,y[i]))/s+denomstar
      numstar=w[i]*c(1,y[i])*y[i+1]/s+numstar
    }
    betastar=solve(denomstar)%*%numstar
    futurestar[B]=sqrt(t(betahat+(betahat-betastar)/sigma)%*%c(1,y[n]))*sample(er,1)
    futurestar1[B]=sqrt(t(betahat+(betahat-betastar)/sigma)%*%c(1,y[n]))*sample(res,1)
  }
  
  futurestar=futurestar[!is.na(futurestar)]
  futurestar1=futurestar1[!is.na(futurestar1)]
  up=quantile(futurestar,.975)
  down=quantile(futurestar,.025)
  up90=quantile(futurestar,.95)
  down90=quantile(futurestar,.05)
  regl=up-down
  regl90=up90-down90
  up1=quantile(futurestar1,.975)
  down1=quantile(futurestar1,.025)
  up901=quantile(futurestar1,.95)
  down901=quantile(futurestar1,.05)
  prel=up1-down1
  prel90=up901-down901
  
  c=0
  c90=0
  c1=0
  c901=0
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=sqrt(.5+.25*y[n])*rlaplace(1,0,1/sqrt(2))
    if((truevalue[i]<up) & truevalue[i]>down) c=c+1
    if((truevalue[i]<up90) & truevalue[i]>down90) c90=c90+1
    if((truevalue[i]<up1) & truevalue[i]>down1) c1=c1+1
    if((truevalue[i]<up901) & truevalue[i]>down901) c901=c901+1
  }
  c=c/1000
  c90=c90/1000
  c1=c1/1000
  c901=c901/1000
  list(regc=c,prec=c1,regl=regl,prel=prel,regc90=c90,prec90=c901,regl90=regl90,prel90=prel90)
}

regc=rep(NA,500)
prec=rep(NA,500)
regl=rep(NA,500)
prel=rep(NA,500)
regc90=rep(NA,500)
prec90=rep(NA,500)
regl90=rep(NA,500)
prel90=rep(NA,500)
require(VGAM)
for (i in 1:500){
  set.seed(5*i)
  results=arch()
  regc[i]=results$regc
  prec[i]=results$prec
  regc90[i]=results$regc90
  prec90[i]=results$prec90
  regl[i]=results$regl
  regl90[i]=results$regl90
  prel[i]=results$prel
  prel90[i]=results$prel90
  print(regc[i])
  print(prec[i])
  print(i)
  save.image("C:/Users/Penny/Dropbox/time series/new sim/ARCH/workspace/arch1laplace50.RData")
}

print(mean(regc))
print(mean(prec))
print(sd(regc))
print(sd(prec))
print(mean(regl))
print(mean(prel))
print(sd(regl))
print(sd(prel))
print(mean(regc90))
print(mean(prec90))
print(sd(regc90))
print(sd(prec90))
print(mean(regl90))
print(mean(prel90))
print(sd(regl90))
print(sd(prel90))