rm(list=ls(all=TRUE))
n=50
phi=0.9
Gboots=function()
{
  temp=rep(0,(n+100))
  temp[1]=rnorm(1)
  e=rnorm((n+100),0,1)
  for (i in 1:(n-1+100)){
    temp[i+1]=phi*(temp[i])+e[i+1]
  }
  u=temp[101:(100+n)]
  x=u[1:(n-1)]
  y=u[2:n]
  fit=lm(y~x)
  while(abs(fit$coef[2])>=1){
    temp=rep(0,(n+100))
    temp[1]=rnorm(1)
    e=rnorm((n+100),0,1)
    for (i in 1:(n-1+100)){
      temp[i+1]=phi*(temp[i])+e[i+1]
    }
    u=temp[101:(100+n)]
    x=u[1:(n-1)]
    y=u[2:n]
    fit=lm(y~x)
  }
  fvhat=predict(fit,data.frame(x=u[n]))
  e=fit$resid
  er=e-mean(e) #fitted residuals
  sigmahat=sd(er)#sigma
  resid=rep(0,(n-1))
  for (i in 1:(n-1)){
    xtemp=x[-i]
    ytemp=y[-i]
    tempfit=lm(ytemp~xtemp)
    resid[i]=y[i]-predict(tempfit,data.frame(xtemp=x[i]))
  }
  res=resid-mean(resid)#predictive residuals
  
  
  Ffroots=rep(NA,1000)
  Fproots=rep(NA,1000)
  #H=sqrt(1-1/(n-1))
  for(i in 1:1000){
    w=rmultinom(1,n-1,rep(1/(n-1),n-1))
    fitstar=lm(y~x,weights=w)
    Ffroots[i]=((fit$coef[2]-fitstar$coef[2])*u[n]+fit$coef[1]-fitstar$coef[1])+sample(er,1)
    Fproots[i]=((fit$coef[2]-fitstar$coef[2])*u[n]+fit$coef[1]-fitstar$coef[1])+sample(res,1)
  }
  
  
  
  #Ff
  Ffdown=fvhat+quantile(Ffroots,.025)
  Ffup=fvhat+quantile(Ffroots,.975)
  Ffl=Ffup-Ffdown
  Ffdown90=fvhat+quantile(Ffroots,.05)
  Ffup90=fvhat+quantile(Ffroots,.95)
  Ffl90=Ffup90-Ffdown90
  #Fp
  Fpdown=fvhat+quantile(Fproots,.025)
  Fpup=fvhat+quantile(Fproots,.975)
  Fpl=Fpup-Fpdown
  Fpdown90=fvhat+quantile(Fproots,.05)
  Fpup90=fvhat+quantile(Fproots,.95)
  Fpl90=Fpup90-Fpdown90
  
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=phi*(u[n])+rnorm(1,0,1)
  }
  
  Ff=0
  Fp=0
  Ff90=0
  Fp90=0
  for (i in 1:1000){
    if((truevalue[i]<Ffup) & truevalue[i]>Ffdown)
      Ff=Ff+1
    if((truevalue[i]<Fpup) & truevalue[i]>Fpdown)
      Fp=Fp+1
    if((truevalue[i]<Ffup90) & truevalue[i]>Ffdown90)
      Ff90=Ff90+1
    if((truevalue[i]<Fpup90) & truevalue[i]>Fpdown90)
      Fp90=Fp90+1
  }
  Ffc=Ff/1000
  Fpc=Fp/1000
  Ffc90=Ff90/1000
  Fpc90=Fp90/1000
  
  list(Ffc=Ffc,Fpc=Fpc,Ffl=Ffl,Fpl=Fpl,Ffc90=Ffc90,Fpc90=Fpc90,Ffl90=Ffl90,Fpl90=Fpl90)
}


Ffc=rep(NA,500)
Fpc=rep(NA,500)
Ffc90=rep(NA,500)
Fpc90=rep(NA,500)
Ffl=rep(NA,500)
Fpl=rep(NA,500)
Ffl90=rep(NA,500)
Fpl90=rep(NA,500)
for (i in 1:500){
  set.seed(5*i)
  results=Gboots()
  Ffc[i]=results$Ffc
  Fpc[i]=results$Fpc
  Ffl[i]=results$Ffl
  Fpl[i]=results$Fpl
  Ffc90[i]=results$Ffc90
  Fpc90[i]=results$Fpc90
  Ffl90[i]=results$Ffl90
  Fpl90[i]=results$Fpl90
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/GBS/ar1_09_normal50_noadj.RData")
  print(i)
}
print(mean(Ffc))
print(mean(Fpc))
print(mean(Ffl))
print(mean(Fpl))
print(sd(Ffl))
print(sd(Fpl))
print(mean(Ffc90))
print(mean(Fpc90))
print(mean(Ffl90))
print(mean(Fpl90))
print(sd(Ffl90))
print(sd(Fpl90))
