rm(list=ls(all=TRUE))
n=50
phi=0.5
compothers=function()
{
  temp=rep(0,(n+100))
  temp[1]=rnorm(1)
  e=rlaplace((n+100),0,1/sqrt(2))
  for (i in 1:(n-1+100)){
    temp[i+1]=phi*(temp[i])+e[i+1]
  }
  u=temp[101:(100+n)]
  x=u[1:(n-1)]
  y=u[2:n]
  fit=lm(y~x)
  while(abs(fit$coef[2])>=1){
    temp=rep(0,(n+100))
    temp[1]=rnorm(1)
    e=rlaplace((n+100),0,1/sqrt(2))
    for (i in 1:(n-1+100)){
      temp[i+1]=phi*(temp[i])+e[i+1]
    }
    u=temp[101:(100+n)]
    x=u[1:(n-1)]
    y=u[2:n]
    fit=lm(y~x)
  }
  fvhat=predict(fit,data.frame(x=u[n]))
  e=fit$resid
  er=e-mean(e)
  sigmahat=sd(er)#sigma
  #resid=rep(0,(n-1))
  #for (i in 1:(n-1)){
  # xtemp=x[-i]
  #ytemp=y[-i]
  #tempfit=lm(ytemp~xtemp)
  #resid[i]=y[i]-predict(tempfit,data.frame(xtemp=x[i]))
  #}
  #res=resid-mean(resid)
  
  #B&J
  Bup=fvhat+qnorm(.975)*sigmahat
  Bdown=fvhat+qnorm(.025)*sigmahat
  Bl=Bup-Bdown
  Bup90=fvhat+qnorm(.95)*sigmahat
  Bdown90=fvhat+qnorm(.05)*sigmahat
  Bl90=Bup90-Bdown90
  
  
  arbootstrap=function(residuals){
    bb=rep(0,(n+100))
    bb[1]=u[1]
    estar=sample(residuals,(n+101),replace=TRUE)
    for(i in 1:(100+n)){
      bb[i+1]=fit$coef[2]*bb[i]+fit$coef[1]+estar[i+1]  	
    }
    b=bb[101:(100+n)]
    fv=bb[n+101]
    list(b=b,fv=fv)
  }
  
  caofvstar=rep(NA,1000)
  sievefvstar=rep(NA,1000)
  Mroot=rep(NA,1000)
  for(i in 1:1000){
    result=arbootstrap(er)
    ustar=result$b
    xstar=ustar[1:(n-1)]
    ystar=ustar[2:(n)]
    fitstar=lm(ystar~xstar)
    Mhat=fitstar$coef[2]*u[n]+fitstar$coef[1]
    Mstar=result$fv
    caofvstar[i]=fvhat+sample(er,1)
    sievefvstar[i]=Mhat+sample(er,1)
    sigmastar=sd(fitstar$resid)#sigma*
    Mroot[i]=(Mstar-Mhat)/sigmastar
  }
  #cao
  caoup=quantile(caofvstar,.975)
  caodown=quantile(caofvstar,.025)
  Cl=caoup-caodown
  caodown90=quantile(caofvstar,.05)
  caoup90=quantile(caofvstar,.950)
  Cl90=caoup90-caodown90
  #sieve
  sieveup=quantile(sievefvstar,.975)
  sievedown=quantile(sievefvstar,.025)
  Sl=sieveup-sievedown
  sievedown90=quantile(sievefvstar,.05)
  sieveup90=quantile(sievefvstar,.950)
  Sl90=sieveup90-sievedown90
  #Masaroto
  Mdown=fvhat+quantile(Mroot,.025)*sigmahat
  Mup=fvhat+quantile(Mroot,.975)*sigmahat
  Ml=Mup-Mdown
  Mdown90=fvhat+quantile(Mroot,.05)*sigmahat
  Mup90=fvhat+quantile(Mroot,.95)*sigmahat
  Ml90=Mup90-Mdown90
  
  truevalue=rep(0,1000)
  for (i in 1:1000){
    truevalue[i]=phi*(u[n])+rlaplace(1,0,1/sqrt(2))
  }
  
  
  B=0;C=0;S=0;M=0; B90=0;C90=0;S90=0;M90=0;
  
  for (i in 1:1000){
    if((truevalue[i]<Bup) & truevalue[i]>Bdown)
      B=B+1
    if((truevalue[i]<caoup) & truevalue[i]>caodown)
      C=C+1
    if((truevalue[i]<sieveup) & truevalue[i]>sievedown)
      S=S+1
    if((truevalue[i]<Mup) & truevalue[i]>Mdown)
      M=M+1 
    if((truevalue[i]<Bup90) & truevalue[i]>Bdown90)
      B90=B90+1
    if((truevalue[i]<caoup90) & truevalue[i]>caodown90)
      C90=C90+1
    if((truevalue[i]<sieveup90) & truevalue[i]>sievedown90)
      S90=S90+1
    if((truevalue[i]<Mup90) & truevalue[i]>Mdown90)
      M90=M90+1
  }
  Bc=B/1000;Cc=C/1000;Sc=S/1000;Mc=M/1000;
  Bc90=B90/1000;Cc90=C90/1000;Sc90=S90/1000;Mc90=M90/1000;
  list(Bc=Bc,Cc=Cc,Sc=Sc,Mc=Mc,Bc90=Bc90,Cc90=Cc90,Sc90=Sc90,Mc90=Mc90,
       Bl=Bl,Cl=Cl,Sl=Sl,Ml=Ml,Bl90=Bl90,Cl90=Cl90,Sl90=Sl90,Ml90=Ml90)
}

Bc=rep(NA,500);Cc=rep(NA,500);Sc=rep(NA,500);Mc=rep(NA,500);
Bl=rep(NA,500);Cl=rep(NA,500);Sl=rep(NA,500);Ml=rep(NA,500);
Bc90=rep(NA,500);Cc90=rep(NA,500);Sc90=rep(NA,500);Mc90=rep(NA,500);
Bl90=rep(NA,500);Cl90=rep(NA,500);Sl90=rep(NA,500);Ml90=rep(NA,500);
for (i in 1:500){
  set.seed(5*i)
  results=compothers()
  Bc[i]=results$Bc;Cc[i]=results$Cc;Sc[i]=results$Sc;Mc[i]=results$Mc;
  Bl[i]=results$Bl;Cl[i]=results$Cl;Sl[i]=results$Sl;Ml[i]=results$Ml;
  Bc90[i]=results$Bc90;Cc90[i]=results$Cc90;Sc90[i]=results$Sc90;Mc90[i]=results$Mc90;
  Bl90[i]=results$Bl90;Cl90[i]=results$Cl90;Sl90[i]=results$Sl90;Ml90[i]=results$Ml90;
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/ar/8 methods and others/workspaces/ar1_others_laplace50.RData")
  print(i)
}
print(mean(Bc));print(mean(Cc));print(mean(Sc));print(mean(Mc));
print(mean(Bl));print(mean(Cl));print(mean(Sl));print(mean(Ml));
print(sd(Bl));print(sd(Cl));print(sd(Sl));print(sd(Ml));
print(mean(Bc90));print(mean(Cc90));print(mean(Sc90));print(mean(Mc90));
print(mean(Bl90));print(mean(Cl90));print(mean(Sl90));print(mean(Ml90));
print(sd(Bl90));print(sd(Cl90));print(sd(Sl90));print(sd(Ml90))