rm(list=ls(all=TRUE))
f=function(x){
	func=1
	for(i in 1:20) func=func*(x-1-.1*i)
}
n=50
arbootcompare=function(){
temp=rep(0,(n+100))
temp[1]=rnorm(1)
temp[2]=rnorm(1)
e=rnorm((n+100),0,1)
for (i in 1:(n-2+100)){
  temp[i+2]=1.55*temp[i+1]-.6*temp[i]+e[i+2]
}
u=temp[101:(100+n)]

fit=lm(u[-c(1,2)]~u[-c(1,n)]+u[-c(n-1,n)])
while(fit$coef[2]-1>abs(fit$coef[3])){
  temp=rep(0,(n+100))
  temp[1]=rnorm(1)
  temp[2]=rnorm(1)
  e=rnorm((n+100),0,1)
  for (i in 1:(n-2+100)){
    temp[i+2]=1.55*temp[i+1]-.6*temp[i]+e[i+2]
  }
  u=temp[101:(100+n)]
  fit=lm(u[-c(1,2)]~u[-c(1,n)]+u[-c(n-1,n)])
}
e=fit$resid
er=e-mean(e)
fvhat=fit$coef[2]*u[n]+fit$coef[3]*u[n-1]+fit$coef[1]
#predictive residuals
resid=rep(0,(n-2))
for(i in 1:(n-2)){
  tempfit=lm(u[-c(1,2,i+2)]~u[-c(1,i+1,n)]+u[-c(i,n-1,n)])
  resid[i]=u[i+2]-tempfit$coef[2]*u[i+1]-tempfit$coef[3]*u[i]-tempfit$coef[1]
}
res=resid-mean(resid)
sigmahat=sd(er)
#################B&J#############################
Bup=fvhat+qnorm(.975)*sigmahat
Bdown=fvhat+qnorm(.025)*sigmahat
Bl=Bup-Bdown
Bup90=fvhat+qnorm(.95)*sigmahat
Bdown90=fvhat+qnorm(.05)*sigmahat
Bl90=Bup90-Bdown90

bootstrap=function(residuals){
  bb=rep(0,(n+100))
  bb[1]=u[1]
  bb[2]=u[2]
  estar=sample(residuals,(n+101),replace=TRUE)
  for(i in 1:(99+n)){
    bb[i+2]=fit$coef[2]*bb[i+1]+fit$coef[3]*bb[i]+fit$coef[1]+estar[i+2]		
  }
  b=bb[101:(100+n)]
  fv=fit$coef[2]*u[n]+fit$coef[3]*u[n-1]+fit$coef[1]+estar[(n+101)]
  fv1=bb[101+n]
  list(b=b,fv=fv,fv1=fv1)
}

FSfroot=rep(NA,1000)
Mroot=rep(NA,1000)
caofvstar=rep(NA,1000)
sievefvstar=rep(NA,1000)
Ffhat=rep(NA,1000)
Ffstar=rep(NA,1000)
for(i in 1:1000){
  result=bootstrap(er)
  ustar=result$b
  fitstar=lm(ustar[-c(1,2)]~ustar[-c(1,n)]+ustar[-c(n-1,n)])
  Ffhat[i]=fitstar$coef[2]*u[n]+fitstar$coef[3]*u[n-1]+fitstar$coef[1]
  Ffstar[i]=result$fv
  sigmastar=sd(fitstar$resid)
  FSfroot[i]=(Ffstar[i]-Ffhat[i])/sigmastar#studentized bootstrap root
  Mhat=fitstar$coef[2]*ustar[n]+fitstar$coef[3]*ustar[n-1]+fitstar$coef[1]
  Mstar=result$fv1
  Mroot[i]=(Mstar-Mhat)/sigmastar#M studentized bootstrap root
  caofvstar[i]=fvhat+sample(er,1)#cao
  sievefvstar[i]=fitstar$coef[2]*u[n]+fitstar$coef[3]*u[n-1]+fitstar$coef[1]+sample(er,1)#sieve  
}
#preditive
FSproot=rep(NA,1000)
Fphat=rep(NA,1000)
Fpstar=rep(NA,1000)
for( i in 1:1000){
  result=bootstrap(res)
  ustar=result$b
  fitstar=lm(ustar[-c(1,2)]~ustar[-c(1,n)]+ustar[-c(n-1,n)])
  Fphat[i]=fitstar$coef[2]*u[n]+fitstar$coef[3]*u[n-1]+fitstar$coef[1]
  Fpstar[i]=result$fv
  sigmastar=sd(fitstar$resid)
  FSproot[i]=(Fpstar[i]-Fphat[i])/sigmastar
}

backbootstrap=function(residuals){
  estar=sample(residuals,(n+101),replace=TRUE)
  wstar=rep(0,(n+100))
  wstar[1]=estar[1]-fit$coef[2]*estar[2]-fit$coef[3]*estar[3]
  wstar[2]=fit$coef[2]*wstar[1]+estar[2]-fit$coef[2]*estar[3]-fit$coef[3]*estar[4]
  for(i in 1:(98+n)){
    wstar[i+2]=fit$coef[2]*wstar[i+1]+fit$coef[3]*wstar[i]+estar[i+2]-fit$coef[2]*estar[i+1]-fit$coef[3]*estar[i]
  }
  backerr=wstar[101:(100+n)]
  b=rep(0,n)
  b[n]=u[n]
  b[n-1]=u[n-1]
  for(i in 2:(n-1)){
    b[n-i]=fit$coef[1]+fit$coef[2]*b[n-i+1]+fit$coef[3]*b[n-i+2]+backerr[n-i]
  }
  fv=fit$coef[2]*u[n]+fit$coef[3]*u[n-1]+fit$coef[1]+estar[n+101]
  list(b=b,fv=fv)
}
Bfstar=rep(NA,1000)
Bfhat=rep(NA,1000)
BSfroot=rep(NA,1000)
for(i in 1:1000){
  result=backbootstrap(er)
  ustar=result$b
  fitstar=lm(ustar[-c(1,2)]~ustar[-c(1,n)]+ustar[-c(n-1,n)])
  Bfhat[i]=fitstar$coef[2]*u[n]+fitstar$coef[3]*u[n-1]+fitstar$coef[1]
  Bfstar[i]=result$fv
  sigmastar=sd(fitstar$resid)
  BSfroot[i]=(Bfstar[i]-Bfhat[i])/sigmastar
}
Bpstar=rep(NA,1000)
Bphat=rep(NA,1000)
BSproot=rep(NA,1000)
for(i in 1:1000){
  result=backbootstrap(res)
  ustar=result$b
  fitstar=lm(ustar[-c(1,2)]~ustar[-c(1,n)]+ustar[-c(n-1,n)])
  Bphat[i]=fitstar$coef[2]*u[n]+fitstar$coef[3]*u[n-1]+fitstar$coef[1]
  Bpstar[i]=result$fv
  sigmastar=sd(fitstar$resid)
  BSproot[i]=(Bpstar[i]-Bphat[i])/sigmastar
}
#Masaroto
Mdown=fvhat+quantile(Mroot,.025)*sigmahat
Mup=fvhat+quantile(Mroot,.975)*sigmahat
Ml=Mup-Mdown
Mdown90=fvhat+quantile(Mroot,.05)*sigmahat
Mup90=fvhat+quantile(Mroot,.95)*sigmahat
Ml90=Mup90-Mdown90
#FSf
FSfdown=fvhat+quantile(FSfroot,.025)*sigmahat
FSfup=fvhat+quantile(FSfroot,.975)*sigmahat
FSfl=FSfup-FSfdown
FSfdown90=fvhat+quantile(FSfroot,.05)*sigmahat
FSfup90=fvhat+quantile(FSfroot,.95)*sigmahat
FSfl90=FSfup90-FSfdown90
#FSp
FSpdown=fvhat+quantile(FSproot,.025)*sigmahat
FSpup=fvhat+quantile(FSproot,.975)*sigmahat
FSpl=FSpup-FSpdown
FSpdown90=fvhat+quantile(FSproot,.05)*sigmahat
FSpup90=fvhat+quantile(FSproot,.95)*sigmahat
FSpl90=FSpup90-FSpdown90
#BSf
BSfdown=fvhat+quantile(BSfroot,.025)*sigmahat
BSfup=fvhat+quantile(BSfroot,.975)*sigmahat
BSfl=BSfup-BSfdown
BSfdown90=fvhat+quantile(BSfroot,.05)*sigmahat
BSfup90=fvhat+quantile(BSfroot,.95)*sigmahat
BSfl90=BSfup90-BSfdown90
#BSp
BSpdown=fvhat+quantile(BSproot,.025)*sigmahat
BSpup=fvhat+quantile(BSproot,.975)*sigmahat
BSpl=BSpup-BSpdown
BSpdown90=fvhat+quantile(BSproot,.05)*sigmahat
BSpup90=fvhat+quantile(BSproot,.95)*sigmahat
BSpl90=BSpup90-BSpdown90
#cao
caoup=quantile(caofvstar,.975)
caodown=quantile(caofvstar,.025)
Cl=caoup-caodown
caodown90=quantile(caofvstar,.05)
caoup90=quantile(caofvstar,.950)
Cl90=caoup90-caodown90
#sieve
sieveup=quantile(sievefvstar,.975)
sievedown=quantile(sievefvstar,.025)
Sl=sieveup-sievedown
sievedown90=quantile(sievefvstar,.05)
sieveup90=quantile(sievefvstar,.950)
Sl90=sieveup90-sievedown90
#Ff
Ffdown=fvhat+quantile(Ffstar-Ffhat,.025)
Ffup=fvhat+quantile(Ffstar-Ffhat,.975)
Ffl=Ffup-Ffdown
Ffdown90=fvhat+quantile(Ffstar-Ffhat,.05)
Ffup90=fvhat+quantile(Ffstar-Ffhat,.950)
Ffl90=Ffup90-Ffdown90
#Fp
Fpdown=fvhat+quantile(Fpstar-Fphat,.025)
Fpup=fvhat+quantile(Fpstar-Fphat,.975)
Fpl=Fpup-Fpdown
Fpdown90=fvhat+quantile(Fpstar-Fphat,.05)
Fpup90=fvhat+quantile(Fpstar-Fphat,.950)
Fpl90=Fpup90-Fpdown90
#Bf
Bfdown=fvhat+quantile(Bfstar-Bfhat,.025)
Bfup=fvhat+quantile(Bfstar-Bfhat,.975)
Bfl=Bfup-Bfdown
Bfdown90=fvhat+quantile(Bfstar-Bfhat,.05)
Bfup90=fvhat+quantile(Bfstar-Bfhat,.950)
Bfl90=Bfup90-Bfdown90
#Bp
Bpdown=fvhat+quantile(Bpstar-Bphat,.025)
Bpup=fvhat+quantile(Bpstar-Bphat,.975)
Bpl=Bpup-Bpdown
Bpdown90=fvhat+quantile(Bpstar-Bphat,.05)
Bpup90=fvhat+quantile(Bpstar-Bphat,.950)
Bpl90=Bpup90-Bpdown90

truevalue=rep(0,1000)
for (i in 1:1000){
  truevalue[i]=1.55*(u[n])-.6*u[n-1]+rnorm(1,0,1)
}

B=0; C=0;S=0;M=0;FSf=0;FSp=0;BSf=0;BSp=0;Ff=0;Fp=0;Bf=0;Bp=0
B90=0; C90=0;S90=0;M90=0;FSf90=0;FSp90=0;BSf90=0;BSp90=0;Ff90=0;Fp90=0;Bf90=0;Bp90=0


for (i in 1:1000){
  if((truevalue[i]<Bup) & truevalue[i]>Bdown)
    B=B+1
  if((truevalue[i]<caoup) & truevalue[i]>caodown)
    C=C+1
  if((truevalue[i]<sieveup) & truevalue[i]>sievedown)
    S=S+1
  if((truevalue[i]<Mup) & truevalue[i]>Mdown)
    M=M+1 
  if((truevalue[i]<Ffup) & truevalue[i]>Ffdown)
    Ff=Ff+1
  if((truevalue[i]<Fpup) & truevalue[i]>Fpdown)
    Fp=Fp+1
  if((truevalue[i]<Bfup) & truevalue[i]>Bfdown)
    Bf=Bf+1
  if((truevalue[i]<Bpup) & truevalue[i]>Bpdown)
    Bp=Bp+1
  if((truevalue[i]<FSfup) & truevalue[i]>FSfdown)
    FSf=FSf+1
  if((truevalue[i]<FSpup) & truevalue[i]>FSpdown)
    FSp=FSp+1
  if((truevalue[i]<BSfup) & truevalue[i]>BSfdown)
    BSf=BSf+1
  if((truevalue[i]<BSpup) & truevalue[i]>BSpdown)
    BSp=BSp+1
  
  if((truevalue[i]<Bup90) & truevalue[i]>Bdown90)
    B90=B90+1
  if((truevalue[i]<caoup90) & truevalue[i]>caodown90)
    C90=C90+1
  if((truevalue[i]<sieveup90) & truevalue[i]>sievedown90)
    S90=S90+1
  if((truevalue[i]<Mup90) & truevalue[i]>Mdown90)
    M90=M90+1
  if((truevalue[i]<Ffup90) & truevalue[i]>Ffdown90)
    Ff90=Ff90+1
  if((truevalue[i]<Fpup90) & truevalue[i]>Fpdown90)
    Fp90=Fp90+1
  if((truevalue[i]<Bfup90) & truevalue[i]>Bfdown90)
    Bf90=Bf90+1
  if((truevalue[i]<Bpup90) & truevalue[i]>Bpdown90)
    Bp90=Bp90+1
  if((truevalue[i]<FSfup90) & truevalue[i]>FSfdown90)
    FSf90=FSf90+1
  if((truevalue[i]<FSpup90) & truevalue[i]>FSpdown90)
    FSp90=FSp90+1
  if((truevalue[i]<BSfup90) & truevalue[i]>BSfdown90)
    BSf90=BSf90+1
  if((truevalue[i]<BSpup90) & truevalue[i]>BSpdown90)
    BSp90=BSp90+1
}
Bc=B/1000;Cc=C/1000;Sc=S/1000;Mc=M/1000;Ffc=Ff/1000;Fpc=Fp/1000;Bfc=Bf/1000;Bpc=Bp/1000;FSfc=FSf/1000;FSpc=FSp/1000;BSfc=BSf/1000;BSpc=BSp/1000;
Bc=B/1000;Cc=C/1000;Sc=S/1000;Mc=M/1000;Ffc=Ff/1000;Fpc=Fp/1000;Bfc=Bf/1000;Bpc=Bp/1000;FSfc=FSf/1000;FSpc=FSp/1000;BSfc=BSf/1000;BSpc=BSp/1000;
Bc90=B90/1000;Cc90=C90/1000;Sc90=S90/1000;Mc90=M90/1000;
Ffc90=Ff90/1000;Fpc90=Fp90/1000;Bfc90=Bf90/1000;Bpc90=Bp90/1000;FSfc90=FSf90/1000;FSpc90=FSp90/1000;BSfc90=BSf90/1000;BSpc90=BSp90/1000
list(Bc=Bc,Cc=Cc,Sc=Sc,Mc=Mc,Ffc=Ffc,Fpc=Fpc,Bfc=Bfc,Bpc=Bpc,FSfc=FSfc,FSpc=FSpc,BSfc=BSfc,BSpc=BSpc,
Bc90=Bc90,Cc90=Cc90,Sc90=Sc90,Mc90=Mc90,Ffc90=Ffc90,Fpc90=Fpc90,Bfc90=Bfc90,Bpc90=Bpc90,FSfc90=FSfc90,FSpc90=FSpc90,BSfc90=BSfc90,BSpc90=BSpc90,
Bl=Bl,Cl=Cl,Sl=Sl,Ml=Ml,Ffl=Ffl,Fpl=Fpl,Bfl=Bfl,Bpl=Bpl,FSfl=FSfl,FSpl=FSpl,BSfl=BSfl,BSpl=BSpl,
Bl90=Bl90,Cl90=Cl90,Sl90=Sl90,Ml90=Ml90,Ffl90=Ffl90,Fpl90=Fpl90,Bfl90=Bfl90,Bpl90=Bpl90,FSfl90=FSfl90,FSpl90=FSpl90,BSfl90=BSfl90,BSpl90=BSpl90)
}

Bc=rep(NA,500);Cc=rep(NA,500);Sc=rep(NA,500);Mc=rep(NA,500);
Ffc=rep(NA,500);Fpc=rep(NA,500);Bfc=rep(NA,500);Bpc=rep(NA,500);
FSfc=rep(NA,500);FSpc=rep(NA,500);BSfc=rep(NA,500);BSpc=rep(NA,500);
Bl=rep(NA,500);Cl=rep(NA,500);Sl=rep(NA,500);Ml=rep(NA,500);
Ffl=rep(NA,500);Fpl=rep(NA,500);Bfl=rep(NA,500);Bpl=rep(NA,500);
FSfl=rep(NA,500);FSpl=rep(NA,500);BSfl=rep(NA,500);BSpl=rep(NA,500);
Bc90=rep(NA,500);Cc90=rep(NA,500);Sc90=rep(NA,500);Mc90=rep(NA,500);
Ffc90=rep(NA,500);Fpc90=rep(NA,500);Bfc90=rep(NA,500);Bpc90=rep(NA,500);
FSfc90=rep(NA,500);FSpc90=rep(NA,500);BSfc90=rep(NA,500);BSpc90=rep(NA,500);
Bl90=rep(NA,500);Cl90=rep(NA,500);Sl90=rep(NA,500);Ml90=rep(NA,500);
Ffl90=rep(NA,500);Fpl90=rep(NA,500);Bfl90=rep(NA,500);Bpl90=rep(NA,500);
FSfl90=rep(NA,500);FSpl90=rep(NA,500);BSfl90=rep(NA,500);BSpl90=rep(NA,500);

for (i in 1:500){
  set.seed(5*i)
  results=arbootcompare()
  Bc[i]=results$Bc;Cc[i]=results$Cc;Sc[i]=results$Sc;Mc[i]=results$Mc;
  Ffc[i]=results$Ffc;Fpc[i]=results$Fpc;Bfc[i]=results$Bfc;Bpc[i]=results$Bpc;
  FSfc[i]=results$FSfc;FSpc[i]=results$FSpc;BSfc[i]=results$BSfc;BSpc[i]=results$BSpc;
  Bl[i]=results$Bl;Cl[i]=results$Cl;Sl[i]=results$Sl;Ml[i]=results$Ml;
  Ffl[i]=results$Ffl;Fpl[i]=results$Fpl;Bfl[i]=results$Bfl;Bpl[i]=results$Bpl;
  FSfl[i]=results$FSfl;FSpl[i]=results$FSpl;BSfl[i]=results$BSfl;BSpl[i]=results$BSpl;
  Bc90[i]=results$Bc90;Cc90[i]=results$Cc90;Sc90[i]=results$Sc90;Mc90[i]=results$Mc90;
  Ffc90[i]=results$Ffc90;Fpc90[i]=results$Fpc90;Bfc90[i]=results$Bfc90;Bpc90[i]=results$Bpc90;
  FSfc90[i]=results$FSfc90;FSpc90[i]=results$FSpc90;BSfc90[i]=results$BSfc90;BSpc90[i]=results$BSpc90;
  Bl90[i]=results$Bl90;Cl90[i]=results$Cl90;Sl90[i]=results$Sl90;Ml90[i]=results$Ml90;
  Ffl90[i]=results$Ffl90;Fpl90[i]=results$Fpl90;Bfl90[i]=results$Bfl90;Bpl90[i]=results$Bpl90;
  FSfl90[i]=results$FSfl90;FSpl90[i]=results$FSpl90;BSfl90[i]=results$BSfl90;BSpl90[i]=results$BSpl90;
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/ar/8 methods/workspaces/ar2_normal50.RData")
  print(i)
}
print(mean(Bc));print(mean(Cc));print(mean(Sc));print(mean(Mc));print(mean(Ffc));print(mean(Fpc));
print(mean(Bfc));print(mean(Bpc));print(mean(FSfc));print(mean(FSpc));print(mean(BSfc));print(mean(BSpc));
print(mean(Bl));print(mean(Cl));print(mean(Sl));print(mean(Ml));print(mean(Ffl));print(mean(Fpl));
print(mean(Bfl));print(mean(Bpl));print(mean(FSfl));print(mean(FSpl));print(mean(BSfl));print(mean(BSpl));
print(sd(Bl));print(sd(Cl));print(sd(Sl));print(sd(Ml));print(sd(Ffl));print(sd(Fpl));
print(sd(Bfl));print(sd(Bpl));print(sd(FSfl));print(sd(FSpl));print(sd(BSfl));print(sd(BSpl));
print(mean(Bc90));print(mean(Cc90));print(mean(Sc90));print(mean(Mc90));print(mean(Ffc90));print(mean(Fpc90));
print(mean(Bfc90));print(mean(Bpc90));print(mean(FSfc90));print(mean(FSpc90));print(mean(BSfc90));print(mean(BSpc90));
print(mean(Bl90));print(mean(Cl90));print(mean(Sl90));print(mean(Ml90));print(mean(Ffl90));print(mean(Fpl90));
print(mean(Bfl90));print(mean(Bpl90));print(mean(FSfl90));print(mean(FSpl90));print(mean(BSfl90));print(mean(BSpl90));
print(sd(Bl90));print(sd(Cl90));print(sd(Sl90));print(sd(Ml90));print(sd(Ffl90));print(sd(Fpl90));
print(sd(Bfl90));print(sd(Bpl90));print(sd(FSfl90));print(sd(FSpl90));print(sd(BSfl90));print(sd(BSpl90));

