rm(list=ls(all=TRUE))
require(VGAM)
require(tseries)
n=50
armaboots=function(){
  temp=rep(0,(n+100))
  temp[1]=.5
  e=rlaplace((n+100),0,1/sqrt(2))
  for (i in 1:(n-1+100)){
    temp[i+1]=.7*(temp[i])+e[i+1]-.3*e[i]
  }
  u=temp[101:(100+n)]
fit=arma(u,order=c(1,1))
  while(abs(fit$coef[2])>1||abs(fit$coef[1])>1){
    temp=rep(0,(n+100))
    temp[1]=.5
    e=rlaplace((n+100),0,1/sqrt(2))
    for (i in 1:(n-1+100)){
      temp[i+1]=.7*(temp[i])+e[i+1]-.3*e[i]
    }
    u=temp[101:(100+n)]
    fit=arma(u,order=c(1,1))
  }
coef=fit$coef
err=rep(0,n-1)
for(t in 2:n){
  err[t-1]=0
  for(j in 0:(t-2)){
    err[t-1]=err[t-1]+(-coef[2])^{j}*(u[t-j]-coef[3]-coef[1]*u[t-j-1])
  }
}
er=err-mean(err)
fvhat=coef[3]+coef[1]*u[n]+coef[2]*err[n-1]


armabootstrap=function(){
  bb=rep(0,(n+100))
  bb[1]=u[1]
  estar=sample(er,(n+101),replace=TRUE)
  for(i in 1:(100+n)){
    bb[i+1]=coef[3]+coef[1]*bb[i]+estar[i+1]+coef[2]*estar[i]
  }
  b=bb[101:(100+n)]
  fv=b[n+101]
  list(b=b,fv=fv)
}


armafvhat=rep(0,1000)
armafvstar=rep(0,1000)
prrfvstar=rep(0,1000)
for(i in 1:1000){
  #fitted
  result=armabootstrap()
  ustar=result$b
  fitstar=arma(ustar,order=c(1,1))
  coefstar=fitstar$coef
  etemp=0
  for(j in 0:(n-2)){
    etemp=etemp+(-coefstar[2])^{j}*(ustar[n-j]-coefstar[3]-coefstar[1]*ustar[n-j-1])
  }
  armafvhat[i]=coefstar[3]+coefstar[1]*ustar[n]+coefstar[2]*etemp
  armafvstar[i]=result$fv
  #prr
  prrfvstar[i]=coefstar[3]+coefstar[1]*u[n]+sample(er,1)+coefstar[2]*err[n-1]
  
}
interval=armafvstar-armafvhat
up=quantile(interval,.975)
down=quantile(interval,.025)
length=up-down
up90=quantile(interval,.95)
down90=quantile(interval,.05)
length90=up90-down90

prrlength=quantile(prrfvstar,.975)-quantile(prrfvstar,.025)
prrlength90=quantile(prrfvstar,.95)-quantile(prrfvstar,.05)

truevalue=rep(0,1000)
for (i in 1:1000){
  truevalue[i]=.7*(u[n])+rlaplace(1,0,1/sqrt(2))-.3*e[n+100]
}

k=0
L=0
prrk=0
prrL=0
for (i in 1:1000){
  if((truevalue[i]<fvhat+up) & (truevalue[i]>fvhat+down))
    k=k+1
  if((truevalue[i]<fvhat+up90) & (truevalue[i]>fvhat+down90))
    L=L+1
  if((truevalue[i]<quantile(prrfvstar,.975)) & (truevalue[i]>quantile(prrfvstar,.025)))
    prrk=prrk+1
  if((truevalue[i]<quantile(prrfvstar,.95)) & (truevalue[i]>quantile(prrfvstar,.05)))
    prrL=prrL+1
}
c=k/1000
c90=L/1000
prrc=prrk/1000
prrc90=prrL/1000
list(c=c,prrc=prrc,l=length,prrl=prrlength,c90=c90,prrc90=prrc90,l90=length90,prrl90=prrlength90)
}
c=rep(NA,500)
c90=rep(NA,500)
l=rep(NA,500)
l90=rep(NA,500)
prrc=rep(NA,500)
prrc90=rep(NA,500)
prrl=rep(NA,500)
prrl90=rep(NA,500)
for(i in 1:500){
  set.seed(5*i)
  results=armaboots()
  c[i]=results$c
  c90[i]=results$c90
  l[i]=results$l
  l90[i]=results$l90
  prrc[i]=results$prrc
  prrc90[i]=results$prrc90
  prrl[i]=results$prrl
  prrl90[i]=results$prrl90
  save.image("C:/Users/Penny/Dropbox/time series/new sim/linear/arma/new/model1_laplace_50notfix.RData")
  print(i)
}
print(mean(c))
print(mean(prrc))
print(mean(l))
print(mean(prrl))
print(sd(l))
print(sd(prrl))
print(mean(c90))
print(mean(prrc90))
print(mean(l90))
print(mean(prrl90))
print(sd(l90))
print(sd(prrl90))